Debian Bug report logs - #350357
nbd: Gets confused on client shutdown and fills syslog

version graph

Package: nbd-server; Maintainer for nbd-server is Wouter Verhelst <wouter@debian.org>; Source for nbd-server is src:nbd.

Reported by: Daniel Jacobowitz <dan@debian.org>

Date: Sun, 29 Jan 2006 06:33:01 UTC

Severity: important

Found in version nbd-server/1:2.8.3-1

Fixed in version nbd/1:2.8.3-2

Done: Wouter Verhelst <wouter@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Wouter Verhelst <wouter@debian.org>:
Bug#350357; Package nbd-server. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
New Bug report received and forwarded. Copy sent to Wouter Verhelst <wouter@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: nbd: Gets confused on client shutdown and fills syslog
Date: Sun, 29 Jan 2006 01:18:06 -0500
Package: nbd-server
Version: 1:2.8.3-1
Severity: important

Jan 28 14:34:06 caradoc nbd_server[28890]: connect from 192.168.1.139, assigned file is /space/chroot/mips-nbd.img
Jan 28 14:34:06 caradoc nbd_server[28890]: Can't open authorization file (null) (Bad address).
Jan 28 14:34:06 caradoc nbd_server[28890]: Authorized client
Jan 28 14:34:06 caradoc nbd_server[14840]: Starting to serve
Jan 28 14:34:06 caradoc nbd_server[14840]: size of exported file/device is 536870912
Jan 28 14:42:21 caradoc nbd_server[14840]: Disconnect request received.
Jan 28 14:42:21 caradoc nbd_server[14840]: accept: Socket operation on non-socket
Jan 28 14:42:27 caradoc last message repeated 230299 times
Jan 28 14:42:27 caradoc mountd[10629]: authenticated unmount request from bcm.them.org:1009 for /space (/space)
Jan 28 14:42:27 caradoc nbd_server[14840]: accept: Socket operation on non-socket
Jan 28 14:42:58 caradoc last message repeated 1190456 times
Jan 28 14:43:59 caradoc last message repeated 2478818 times
Jan 28 14:45:00 caradoc last message repeated 2424694 times
Jan 28 14:46:01 caradoc last message repeated 2406191 times

Then two nbd server processes somehow started fighting over syslog (not sure
why, the board that was powered on only uses one nbd device).  That killed
the syslog message repetition check, since the PIDs were different, and
generated 1.8GB of log files in a couple of hours.

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable')
Architecture: amd64 (x86_64)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.15-rc1
Locale: LANG=en_US, LC_CTYPE=en_US (charmap=ISO-8859-1)

Versions of packages nbd-server depends on:
ii  debconf [debconf-2.0]         1.4.67     Debian configuration management sy
ii  libc6                         2.3.5-11   GNU C Library: Shared libraries an
ii  libglib2.0-0                  2.8.5-1    The GLib library of C routines

nbd-server recommends no packages.

-- debconf information:
* nbd-server/filename: /space/chroot/mips-nbd.img
* nbd-server/port: 1011
* nbd-server/filename1: /space/chroot/arm-nbd.img
* nbd-server/filename2: /space/chroot/arm-swap.img
* nbd-server/number: 3
* nbd-server/port1: 1012
  nbd-server/autogen:
* nbd-server/port2: 1013



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#350357; Package nbd-server. Full text and rfc822 format available.

Acknowledgement sent to Wouter Verhelst <wouter@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 350357@bugs.debian.org (full text, mbox):

From: Wouter Verhelst <wouter@debian.org>
To: Daniel Jacobowitz <dan@debian.org>, 350357@bugs.debian.org
Subject: Re: Bug#350357: nbd: Gets confused on client shutdown and fills syslog
Date: Mon, 30 Jan 2006 14:01:12 +0100
Hi,

On Sun, Jan 29, 2006 at 01:18:06AM -0500, Daniel Jacobowitz wrote:
> Package: nbd-server
> Version: 1:2.8.3-1
> Severity: important
> 
> Jan 28 14:34:06 caradoc nbd_server[28890]: connect from 192.168.1.139, assigned file is /space/chroot/mips-nbd.img
> Jan 28 14:34:06 caradoc nbd_server[28890]: Can't open authorization file (null) (Bad address).
> Jan 28 14:34:06 caradoc nbd_server[28890]: Authorized client
> Jan 28 14:34:06 caradoc nbd_server[14840]: Starting to serve
> Jan 28 14:34:06 caradoc nbd_server[14840]: size of exported file/device is 536870912
> Jan 28 14:42:21 caradoc nbd_server[14840]: Disconnect request received.
> Jan 28 14:42:21 caradoc nbd_server[14840]: accept: Socket operation on non-socket

Hmm. That shouldn't happen; this is the child process which was forked
off to serve the client, which at that point should quit rather than try
to run accept() on the server socket (nbd-server is written with
fork-per-client semantics). Since that server socket has been closed at
that point for the child, obviously we get an error.

> Jan 28 14:42:27 caradoc last message repeated 230299 times

... and an infinite loop. Awtch.

> Jan 28 14:42:27 caradoc mountd[10629]: authenticated unmount request from bcm.them.org:1009 for /space (/space)
> Jan 28 14:42:27 caradoc nbd_server[14840]: accept: Socket operation on non-socket
> Jan 28 14:42:58 caradoc last message repeated 1190456 times
> Jan 28 14:43:59 caradoc last message repeated 2478818 times
> Jan 28 14:45:00 caradoc last message repeated 2424694 times
> Jan 28 14:46:01 caradoc last message repeated 2406191 times
> 
> Then two nbd server processes somehow started fighting over syslog
> (not sure why, the board that was powered on only uses one nbd
> device).

One would be the server which is listening to the socket we got from
socket() and did bind() on; the other would be the child process that
was forked off after the parent did accept() and which is spawned to
handle a client.

It would be interesting to know what message, exactly, the other process
was sending out. Was this the same "Socket operation on non-socket"
message, or did you see something else?

-- 
.../ -/ ---/ .--./ / .--/ .-/ .../ -/ ../ -./ --./ / -.--/ ---/ ..-/ .-./ / -/
../ --/ ./ / .--/ ../ -/ ..../ / -../ ./ -.-./ ---/ -../ ../ -./ --./ / --/
-.--/ / .../ ../ --./ -./ .-/ -/ ..-/ .-./ ./ .-.-.-/ / --/ ---/ .-./ .../ ./ /
../ .../ / ---/ ..-/ -/ -../ .-/ -/ ./ -../ / -/ ./ -.-./ ..../ -./ ---/ .-../
---/ --./ -.--/ / .-/ -./ -.--/ .--/ .-/ -.--/ .-.-.-/ / ...-.-/



Information forwarded to debian-bugs-dist@lists.debian.org, Wouter Verhelst <wouter@debian.org>:
Bug#350357; Package nbd-server. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to Wouter Verhelst <wouter@debian.org>. Full text and rfc822 format available.

Message #15 received at 350357@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Wouter Verhelst <wouter@debian.org>
Cc: 350357@bugs.debian.org
Subject: Re: Bug#350357: nbd: Gets confused on client shutdown and fills syslog
Date: Mon, 30 Jan 2006 08:48:50 -0500
On Mon, Jan 30, 2006 at 02:01:12PM +0100, Wouter Verhelst wrote:
> One would be the server which is listening to the socket we got from
> socket() and did bind() on; the other would be the child process that
> was forked off after the parent did accept() and which is spawned to
> handle a client.
> 
> It would be interesting to know what message, exactly, the other process
> was sending out. Was this the same "Socket operation on non-socket"
> message, or did you see something else?

Same message.  Note, it was not the same PID as the original parent
process (28890), I believe it was another PID in the 14xxx range.

-- 
Daniel Jacobowitz
CodeSourcery



Reply sent to Wouter Verhelst <wouter@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Daniel Jacobowitz <dan@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #20 received at 350357-close@bugs.debian.org (full text, mbox):

From: Wouter Verhelst <wouter@debian.org>
To: 350357-close@bugs.debian.org
Subject: Bug#350357: fixed in nbd 1:2.8.3-2
Date: Tue, 31 Jan 2006 03:17:05 -0800
Source: nbd
Source-Version: 1:2.8.3-2

We believe that the bug you reported is fixed in the latest version of
nbd, which is due to be installed in the Debian FTP archive:

nbd-client_2.8.3-2_m68k.deb
  to pool/main/n/nbd/nbd-client_2.8.3-2_m68k.deb
nbd-server_2.8.3-2_m68k.deb
  to pool/main/n/nbd/nbd-server_2.8.3-2_m68k.deb
nbd_2.8.3-2.diff.gz
  to pool/main/n/nbd/nbd_2.8.3-2.diff.gz
nbd_2.8.3-2.dsc
  to pool/main/n/nbd/nbd_2.8.3-2.dsc



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 350357@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Wouter Verhelst <wouter@debian.org> (supplier of updated nbd package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Tue, 31 Jan 2006 11:17:25 +0100
Source: nbd
Binary: nbd-client nbd-server
Architecture: source m68k
Version: 1:2.8.3-2
Distribution: unstable
Urgency: low
Maintainer: Wouter Verhelst <wouter@debian.org>
Changed-By: Wouter Verhelst <wouter@debian.org>
Description: 
 nbd-client - the Network Block Device client
 nbd-server - the Network Block Device server
Closes: 350357
Changes: 
 nbd (1:2.8.3-2) unstable; urgency=low
 .
   * Steal patch from CVS for nbd-server.c to make children exit when they
     finish serving, rather than having them loop over "Help, I can't accept()
     anymore!". Closes: #350357.
Files: 
 2ba3e6f05b4799a13feec3d5efedc6bf 586 admin optional nbd_2.8.3-2.dsc
 9bd26a06156ee36da0f2e6534ae024ce 38606 admin optional nbd_2.8.3-2.diff.gz
 a7097a56c3258a33063c227accdb8d8a 33064 admin optional nbd-server_2.8.3-2_m68k.deb
 1cd101e99d016b7d0d4ffcc81e8598ba 30170 admin optional nbd-client_2.8.3-2_m68k.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.2 (GNU/Linux)

iD8DBQFD30REPfwsYq950p4RAiw9AJ9aoahMSFu4J77H0kmYETHZQC3BcgCfezVo
L94f7DU7/dIUuE3frG87/44=
=eAiY
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 26 Jun 2007 00:22:07 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 13:13:47 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.